<?php

class Meme
{

    private ?string $content;

    public function setPage(?int $pageId): static
    {
        $url = 'https://www.memify.ru/';

        if ($pageId) {
            $url .= 'memes/' . $pageId;
        }

        $this->content = file_get_contents($url);

        return $this;
    }

    public function getMemes(): array
    {
        preg_match_all('~<a href="(.*)" data-fancybox data-type="ajax" data-src="(.*)" data-selector=".meme-detail">~i', $this->content, $matches);

        if (empty($matches[1])) {
            return [];
        }

        return array_unique($matches[1]);
    }

    public function nextPageId(): ?int
    {
        preg_match('~<a class="infinite-more-link btn btn-default" href="(.*)">Дальше</a>~i', $this->content, $matches);

        if (isset($matches[1])) {
            return (int)end(explode('/', $matches[1]));
        }

        return null;
    }
}